<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <p>서로 볼 수 <b style="color: red;">없는</b> 강의실입니다. 화면은 강사님께만 전송됩니다.</p>
    <p>다른 기기로 접속하거나, 새 탭을 열어서 하나 이상의 화면을 전송할 수 있습니다.</p>
    <el-row :gutter="20">
      <el-col :span="12">
        <p>내 화면</p>
        <video controls muted width="100%" ref="myVideo"/>
      </el-col>
      <el-col :span="12">
        <p>내 스냅샷</p>
        <canvas ref="myCanvas" width="180" height="180"></canvas>  
      </el-col>
    </el-row>
    <br />
    <img v-show="false" ref="myImage">
    <el-button type="primary" @click="changeVideo()">화면 변경</el-button>
    <!-- <el-button @click="getOtherStudents"> 출석부 가져오기 </el-button> -->
    
    <el-dialog
      :visible.sync="videoSelectorVisible">
      비디오 장치를 선택하세요.
      <el-table
        :data="videoList"
        highlight-current-row
        @current-change="setVideo">
        <el-table-column property="label" label="장치 이름"></el-table-column>
      </el-table>
    </el-dialog>

    <br />
    <br />

    <template v-for="student in listOfStudents">
      <span :key="student.user_id">
        <span v-for="camera in student.cam" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative"  :key="camera.socket_id">
          <i class="fa fa-circle" v-show="!camera.is_connecting" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <i class="fa fa-circle" v-show="camera.is_connecting" style="position: absolute; top: 7px; left: 15px; color:green"></i>
          <img :src="camera.src" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
        <span v-show="student.cam.length === 0" style="display:inline-block; vertical-align: top; width: 200px; text-align:center; position: relative">
          <i class="fa fa-circle" style="position: absolute; top: 7px; left: 15px; color:red"></i>
          <img :src="'https://image.flaticon.com/icons/svg/167/167750.svg'" width="180" height="180" />
          <br/>
            {{ student.name }}
          <br/>
        </span>
      </span>
    </template>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';


export default {
  name: 'RealtimeWebcamLectureStudent',
  data() {
    return {
      videoList: [],
      videoSelectorVisible: false,

      myVideo: undefined,
      myCanvas: undefined,
      myImage: undefined,
      
      videoDeviceId: undefined,
      videoStream: undefined,

      interval: undefined,

      listOfStudents: [],
    };
  },
  mounted() {
    const vm = this;
    vm.myVideo = vm.$refs.myVideo;
    vm.myCanvas = vm.$refs.myCanvas;
    vm.myImage = vm.$refs.myImage;
    vm.setVideo('default');

    // 소켓 연결 및 주기적으로 보내는 신호, 리스너 등록

    // 강사 - 학생 접속 관련
    const params = {
      lecture_id: vm.lectureId,
      user_id: utils.getUserIdFromJwt()
    };
    vm.sockets.subscribe("CONNECTED", () => {
      vm.$socket.emit("JOIN_LECTURE", JSON.stringify(params));
    });
  },
  async beforeDestory() {
    const vm = this;
    vm.interval.clearInterval();
  },
  methods: {
    async changeVideo(){
      const vm = this;

      try {
        // 비디오 목록 가져오기
        let enumeratorPromise = await navigator.mediaDevices.enumerateDevices();
        vm.videoList = enumeratorPromise.filter(x => x.kind === 'videoinput');
        vm.videoList.push({
          deviceId: null,
          label: '사용 안함',
        });
        console.log('vm.videoList = ', vm.videoList);
      } catch (err) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.FAILED1'),
          type: 'warning',
        });
        return;
      }
      vm.videoSelectorVisible = true;
    },
    async setVideo(arg) {
      const vm = this;
      console.log('@setVideo');
      console.log('arg = ', arg);

      if(vm.interval) {
        console.log('vm.interval = ', vm.interval);
        clearInterval(vm.interval);
      }

      if (!arg) return; // 매개변수 없이 오는 경우 (버튼 클릭 직후) 처리

      let videoConstraint = {
        deviceId: arg.deviceId,
        frameRate: { ideal: 30, max: 30 },
        width: 320,
        height: 200,
      };

      if (arg === 'default') videoConstraint.deviceId = undefined; // 최초에 아무거나 잡기 위해 사용

      vm.videoStream = await navigator.mediaDevices.getUserMedia({
        audio: true,
        video: videoConstraint,
      });
      vm.myVideo.srcObject = vm.videoStream; // TODO : 나중에 서버에서 가져오는 것으로 수정
      vm.myVideo.autoplay = true;

      vm.videoSelectorVisible = false;
        
      vm.sendSnapshot();
    },
    // 주기적 전송
    async sendSnapshot() {
      console.log('@sendSnapshot');
      const vm = this;

      const context = vm.myCanvas.getContext('2d');

      vm.interval = setInterval(() => {
        context.drawImage(vm.myVideo, 0, 0, 180, 180);
        vm.myImage = vm.myCanvas.toDataURL('image/png');
        // vm.myImage.src = vm.myCanvas.toDataURL('image/png');
        vm.$socket.emit('SEND_SNAPSHOT', JSON.stringify({
          lecture_id: vm.lectureId,
          from: utils.getUserIdFromJwt(),
          to: 'teacher',
          snapshot: vm.myImage,
          image_type: 'main',
        }));
      }, 5000);
    },
  },
  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
  },
  beforeDestroy() {
    const vm = this;
    clearInterval(vm.interval);
  },
};
</script>